/*
by: Vhid Najafi
mail: geo.vahid@gmail.com
www.vnplugin.com
modify this at your own risk
*/---------------------------------------------------------------

try(destroydialog vndrops)catch()
rollout vndrops "Drop Water 1.0.0"
(
	local vn_pfs
	local op1
	local op2
	local op3
	local op4
	local op5
	local op6
	local op_1
	local op_2
	local op2_3
	local op2_1
	local op2_2
	
	pickbutton pick "Pick Object" autoDisplay:false width:190 pos:[5,5] 
	label picked_obj ".............." pos:[75,30]
	group "Count"
     (
	label l1 "Count:" pos:[10,70]
	spinner sp_count "" range:[1,100000,20] type:#integer pos:[110,70] fieldwidth:60
	
	 label l12 "Drops Count:"  pos:[10,95]
	 spinner sp_dropCount "" range:[0,1000,600]  type:#integer fieldwidth:60 pos:[110,95]
		 
	 label l8 "Spawn Rate:" pos:[10,120]
	 spinner sp_Spawn "" range:[0,1000,40] type:#integer fieldwidth:60 pos:[110,120]
	 )
	 group "Size"
     (
		label l3 "Scale:" pos:[10,170]
	    spinner sp_scale "" range:[0,10000,40]  fieldwidth:60  pos:[110,170]
		 
		 label l4 "Scale Var:" pos:[10,195]
	     spinner sp_scale_var "" range:[0,10000,17]  fieldwidth:60 pos:[110,195]
		 
		 label l9 "Spawn Scale:" pos:[10,220]
	     spinner sp_Spawnscale "" range:[0,1000,97]  fieldwidth:60 pos:[110,220]
	     
	     label l10 "Spawn Scale Var:" pos:[10,245]
	     spinner sp_Spawnscalevar "" range:[0,1000,3]  fieldwidth:60 pos:[110,245]
		 
		  label l14 "Drops Scale:" pos:[10,270]
	     spinner sp_DropScale "" range:[0,1000,30]  fieldwidth:60 pos:[110,270]
	 
	     label l15 "Drops Scale Var:" pos:[10,295]
	     spinner sp_DropScaleVar "" range:[0,1000,12]  fieldwidth:60 pos:[110,295]
	 )
	 group "Spawn life"
     (
		 label l11 "Spawn Life:"  pos:[10,345] 
	     spinner sp_Spawnlife "" range:[0,1000,50]  fieldwidth:60 type:#integer pos:[110,345]
	 
	     label l13 "Spawn Life Var:" pos:[10,370]
	     spinner sp_Spawnlifevar "" range:[0,1000,15]  fieldwidth:60 type:#integer pos:[110,370]
	 )
	 group "Speed"
     (
		 label l2 "Gravity Scale:"  pos:[10,420]
	     spinner sp_gravity "" range:[0,100000 ,50]  fieldwidth:60 pos:[110,420]
		 
	     label l5 "Turbulence:" pos:[10,445]
	     spinner sp_Turbulence "" range:[0,1000,3]   fieldwidth:60 pos:[110,445]
	     
		 label l6 "Speed:" pos:[10,470]
	     spinner sp_speed "" range:[0,10000,2]  fieldwidth:60 pos:[110,470]
	     
	     label l7 "Speed Var:" pos:[10,495]
		 spinner sp_speedVar "" range:[0,10000,3]  fieldwidth:60  pos:[110,495]
	 )
	 
	Button btn_pf "Open PF Source"  width:190 height:30 pos:[5,520] 

	Button calculate "CREATE" width:190 height:30 pos:[5,560] 
	
	
	on btn_pf pressed do particleFlow.openParticleView()
	on calculate pressed do
	(
		if(isvalidnode pick.object)then
		(
		vn_pfs = PF_Source()
		vn_pfs.dir = [0,0,-1]
		vn_pfs.Quantity_Viewport = 100
		particleFlow.BeginEdit()
		--
		op1 = Birth()
		op1.Emit_Start = -5*160
        op1.Emit_Stop =  -5*160
        op1.amount = sp_count.value
		--
		op2 = Position_Object()
        op2.Emitter_Objects = #( pick.object)
		--
		op3 =  Force()
		if(isvalidnode $VN_Gravity_03)then
			(
				--nothing
			)else
			(
				gravity_vn = Gravity()
				gravity_vn.dir = [0,0,-1]
				gravity_vn.name ="VN_Gravity_03"
			)
		if(isvalidnode $VN_wind_03)then
			(
				--nothing
			)else
			(
				wind_vn = wind()
				wind_vn.strength = 0.1
				wind_vn.turbulence = sp_Turbulence.value
				wind_vn.frequency = 1
				wind_vn.name ="VN_wind_03"
			)	
		op3.Force_Space_Warps = #($VN_Gravity_03 , $VN_wind_03)
		op3.Influence = sp_gravity.value
		--
		op4=Speed_By_Surface()
		op4.Surface_Objects =  #( pick.object)
		op4.Speed_Value = sp_speed.value
		op4.Direction_Type = 2
		op4.Speed_Variation = sp_speedVar.value
		op4.Speed_Type = 1
		--
		op5 = Spawn()
		op5.Spawn_Type = 1
		op5.Speed_Inherited = 0
		op5.Divergence = 0
		op5.Spawn_Rate = sp_Spawn.value
		--
		op6 = ShapeLibrary()-- ShapeLibrary()
		op6.Scale_Value = sp_scale.value
		op6.size = 2
		op6.Use_Scale = on
		op6.Scale_Variation = sp_scale_var.value
		op6.Type_3D = 14
		--
		op7 = Material_Static()
		vn_water_mat = vraymtl()
		vn_water_mat.Diffuse = color 255 255 255
		op7.Assigned_Material = vn_water_mat
		--
        op8 = DisplayParticles()
        op8.color = vn_pfs.wireColor
        op8.type = 6
		op8.color = color 45 103 124
		--
		op9 = RenderParticles()
		--
		ev1 = Event()
        ev1.SetPViewLocation (vn_pfs.X_Coord) (vn_pfs.Y_Coord+100)
        particleFlow.EndEdit()
        ev1.AppendAction op1
        ev1.AppendAction op2
        ev1.AppendAction op3
		ev1.AppendAction op4
        ev1.AppendAction op5
		ev1.AppendAction op6
		ev1.AppendAction op7
		ev1.AppendAction op8
		--
        
		-----------------------------------------------------------------
		particleFlow.BeginEdit()
        ev_1 = Event()
	    ev_1.setPViewLocation -300 350
		--
		op_1 = ScaleParticles()
		op_1.type = 4
		op_1.X_Scale_Factor = sp_Spawnscale.value
		op_1.Y_Scale_Factor = sp_Spawnscale.value
		op_1.Z_Scale_Factor = sp_Spawnscale.value
		op_1.X_Scale_Variation = sp_Spawnscalevar.value
		op_1.Y_Scale_Variation = sp_Spawnscalevar.value
		op_1.Z_Scale_Variation = sp_Spawnscalevar.value
		op_1.bias = 2
		--
		op_2 =DeleteParticles()
		op_2.type = 2
		op_2.Life_Span = sp_Spawnlife.value*160
        op_2.variation = sp_Spawnlifevar.value*160
		--
		op_3 = Material_Static()
		op_3.Assigned_Material = vn_water_mat
		 --
		op_4 = DisplayParticles()
        op_4.color = ev_1.wireColor
		op_4.type = 6
		op_4.color = color 45 103 124
		--
		particleFlow.EndEdit()
		
		ev_1.appendAction op_1
        ev_1.appendAction op_2
		ev_1.appendAction op_3
		ev_1.appendAction op_4
		-----------------------------------------------------------------
		particleFlow.BeginEdit()
		--
		op2_1 = Birth()
		op2_1.Emit_Start = 0
        op2_1.Emit_Stop =  0
        op2_1.amount = sp_dropCount.value
		--
		op2_2 = Position_Object()
        op2_2.Emitter_Objects = #( pick.object)
		--
		op2_3 = ShapeLibrary()-- ShapeLibrary()
		op2_3.Scale_Value = sp_DropScale.value
		op2_3.size = 2
		op2_3.Use_Scale = on
		op2_3.Scale_Variation = sp_DropScaleVar.value
		op2_3.Type_3D = 14
		--
		op2_4 = Material_Static()
		vn_water_mat = vraymtl()
		vn_water_mat.Diffuse = color 255 255 255
		op2_4.Assigned_Material = vn_water_mat
		--
        op2_5 = DisplayParticles()
        op2_5.color = vn_pfs.wireColor
        op2_5.type = 6
		op2_5.color = color 45 103 124
		--
		--op9 = RenderParticles()
		--
		ev2 = Event()
        ev2.SetPViewLocation (vn_pfs.X_Coord+230) (vn_pfs.Y_Coord+100)
        particleFlow.EndEdit()
        ev2.AppendAction op2_1
        ev2.AppendAction op2_2
        ev2.AppendAction op2_3
		ev2.AppendAction op2_4
		ev2.AppendAction op2_5
		
		-----------------------------------------------------------------
        op5.setNextActionList  op5 ev_1
		vn_pfs.AppendAction op9
        vn_pfs.AppendInitialActionList ev1
		vn_pfs.AppendInitialActionList ev2
		-----------------------------------------------------------------
		--particleFlow.openParticleView()
		)else
		(
			messagebox "Select Source objects"
		)
		
	)
	
	on sp_count changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op1.amount = val
		)
		
	)

	on sp_gravity changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op3.Influence = val
		)
		
	)
	
	on sp_scale changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op6.Scale_Value = val
		)
		if(val < sp_scale_var.value)then
			(
				sp_scale_var.value = val
			)
	)

	on sp_scale_var changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op6.Scale_Variation = val
		)
		if(val > sp_scale.value)then
			(
				sp_scale.value = val
			)
		
	)
	
	on sp_Turbulence changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			$VN_wind_03.turbulence = val
		)
		
	)

	on sp_speed changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op4.Speed_Value = val
		)
		
	)
	
	on sp_speedVar changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op4.Speed_Variation = val
		)
		
	)
	
	on sp_Spawn changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op5.Spawn_Rate = val
		)
		
	)
	
	on sp_Spawnscale changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op_1.X_Scale_Factor = val
		    op_1.Y_Scale_Factor = val
		    op_1.Z_Scale_Factor = val
		)
		
	)
	
	on sp_Spawnscalevar changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op_1.X_Scale_Variation = val
		    op_1.Y_Scale_Variation = val
		    op_1.Z_Scale_Variation = val
		)
		
	)
	on sp_Spawnlife changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op_2.Life_Span = val*160
		)
		
	)
	
	on sp_Spawnlifevar changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			 op_2.variation = val*160
		)
		
	)

	on sp_dropCount changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op2_1.amount = val
		)
		
	)

	on sp_DropScale changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op2_3.Scale_Value = val
		)
		
	)	
	
	on sp_DropScaleVar changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_03)then
		(
			op2_3.Scale_Variation = val
		)
		
	)
	---------------------------------------
	on pick picked obj do 
	(
		picked_obj.text = obj.name
		if (isvalidnode vn_pfs)then
		(
		 op2.Emitter_Objects = #( obj)
		 op4.Surface_Objects =  #( obj)
		 op2_2.Emitter_Objects = #(obj)
		)
	)
	
)
createdialog vndrops 200 595 150 90
