/*
by: Vhid Najafi
mail: geo.vahid@gmail.com
www.vnplugin.com
modify this at your own risk
*/
try(destroydialog vnscatter)catch()
rollout vnscatter "Scatter 1.0.0"
(
	local vn_pfs
	local op1
	local op3
	local op2
	local op5
	
	pickbutton pick "Pick Object" autoDisplay:false width:150 pos:[5,5] 
	label picked_obj ".............." pos:[50,30]
	pickbutton pick_dis "Pick Distribution Surface" autoDisplay:false  width:150 pos:[5,55] 
	label distributed_obj ".............." pos:[50,80]
	
	label l1 "Count:" pos:[10,110]
	spinner sp_count "" range:[1,100000,100] type:#integer pos:[80,110] fieldwidth:60
	label l2 "Rotation Div.:" pos:[10,135]
	spinner sp_rotation "" range:[0,180,6] type:#integer pos:[80,135] fieldwidth:60
	label l3 "Scale:" pos:[10,160]
	spinner sp_basescale "" range:[0,10000,100] pos:[80,160] fieldwidth:60
	label l4 "Scale Var.:" pos:[10,185]
	spinner sp_scale "" range:[0,100,25] type:#integer pos:[80,185] fieldwidth:60
	checkbox ch_animate "Animatable"  pos:[10,210]
	
	label l5 "Anim. Offset:" pos:[10,235]
	spinner sp_anim_offset "" range:[0,1000000,50] type:#integer pos:[80,235] fieldwidth:60
	label l6 "Random seed:" pos:[10,260]
	spinner sp_seed "" range:[0,1000000,12] type:#integer pos:[80,260] fieldwidth:60
	
	Button btn_pf "Open PF Source"  width:150 height:30 pos:[5,285] 
	on btn_pf pressed do particleFlow.openParticleView()
	
	Button calculate "CREATE" width:150 height:30 pos:[5,330] 
	on calculate pressed do
	(
		if(isvalidnode pick_dis.object and isvalidnode pick.object)then
		(
			vn_pfs = PF_Source()
		vn_pfs.Quantity_Viewport = 100
		particleFlow.BeginEdit()
		--
		op1 = Birth()
        op1.Emit_Stop = 0
        op1.amount = sp_count.value
		--
		op2 = Position_Object()
        op2.Emitter_Objects = #( pick_dis.object)
		--
		op3 = Rotation()
		op3.direction = 1
        op3.Divergence = sp_rotation.value
		--
		op4 = Camera_Culling()
		--
		op5 = Shape_instance()-- ShapeLibrary()
		op5.Scale_Value = sp_basescale.value
		
		new_obj =  pick.object
		if ( isvalidnode new_obj.parent)then new_obj = new_obj.parent
        op5.Shape_Object = new_obj
			
        op5.variation = sp_scale.value
        op5.Animated_Shape = ch_animate.checked
		op5.Add_Random_Offset = on
		op5.Random_Offset  = sp_anim_offset.value *160
		--
		op6 = RenderParticles()
		--
        op7 = DisplayParticles()
        op7.color = vn_pfs.wireColor
        op7.type = 6
		--
		ev1 = Event()
        ev1.SetPViewLocation (vn_pfs.X_Coord) (vn_pfs.Y_Coord+100)
        particleFlow.EndEdit()
        ev1.AppendAction op1
        ev1.AppendAction op2
        ev1.AppendAction op3
		ev1.AppendAction op4
        ev1.AppendAction op5
		ev1.AppendAction op7
		--
        vn_pfs.AppendAction op6
        vn_pfs.AppendInitialActionList ev1
		
		particleFlow.openParticleView()
		)else
		(
			messagebox "Select scatter objects"
		)
		
	)
	
	on sp_count changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op1.amount = val
		)
		
	)
	on sp_rotation changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op3.Divergence = val
		)
		
	)
	on sp_scale changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op5.variation = val
		)
		
	)
	
	on ch_animate changed theState do 
	(
		if (isvalidnode vn_pfs)then
		(
			op5.Animated_Shape = ch_animate.checked
		)
	)

	on sp_anim_offset changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op5.Random_Offset  = val*160
		)
		
	)
	
	
	on sp_basescale changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op5.Scale_Value = val
		)
		
	)
	
	on sp_seed changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op2.Random_Seed = val
		)
		
	)
	
	on pick picked obj do 
	(
		new_obj =  obj
		if ( isvalidnode new_obj.parent)then new_obj = new_obj.parent
		picked_obj.text = new_obj.name
		if (isvalidnode vn_pfs)then
		(
			op5.Shape_Object = new_obj
		)
	)
	
	on pick_dis picked obj do 
	(
		distributed_obj.text = obj.name
		if (isvalidnode vn_pfs)then
		(
			op2.Emitter_Objects = #(obj)
		)
	)
	
)
createdialog vnscatter 160 365 150 90
