/*
by: Vhid Najafi
mail: geo.vahid@gmail.com
www.vnplugin.com
modify this at your own risk
*/---------------------------------------------------------------

try(destroydialog vnfountain)catch()
rollout vnfountain "Fountain 1.0.0"
(
	local vn_pfs
	local op1
	local op2
	local op3
	local op4
	local op5
	local op6
	local op_1
	local op_2
	local op_3
	
	pickbutton pick "Pick Object" autoDisplay:false width:190 pos:[5,5] 
	label picked_obj ".............." pos:[75,30]
	group "Source Parameters"
     (
	label l1 "Count:" pos:[10,70]
	spinner sp_count "" range:[1,100000,2000] type:#integer pos:[110,70] fieldwidth:60
	
	label l2 "Speed:" pos:[10,95]
	spinner sp_speed "" range:[0,100000 ,400] pos:[110,95] fieldwidth:60
	
	label l3 "Speed Variation:" pos:[10,120]
	spinner sp_var "" range:[0,10000,25] pos:[110,120] fieldwidth:60
	
	label l4 "Speed Divergence:" pos:[10,145]
	spinner sp_div "" range:[0,100,15] pos:[110,145] fieldwidth:60
	 )
	 
	group "Spawn Parameters"
     (
		 label l6 "Num of Offsprings:" pos:[10,190]
	     spinner sp_Offsprings"" range:[0,1000,20] type:#integer pos:[110,190] fieldwidth:60 
		 
		 label l7 "Speed Variation:" pos:[10,215]
	     spinner sp_speedvar"" range:[0,100000,22]  pos:[110,215] fieldwidth:60
		 
		 label l11 "Spawn Life:" pos:[10,240]
	     spinner sp_Spawnlife "" range:[0,100000,5]  type:#integer fieldwidth:60 pos:[110,240]
	 )
	 group "Scale Parameters"
     (
		 label l8 "Scale:"  pos:[10,285]
	     spinner sp_scale "" range:[0,100000,100]  fieldwidth:60 pos:[110,285]
		 
		 label l9 "Scale var:" pos:[10,310]
	     spinner sp_scalevar "" range:[0,100000,50]  fieldwidth:60 pos:[110,310]
		 
		 label l12 "Spawn Scale:"  pos:[10,335]
	     spinner sp_SpawnScale "" range:[0,100000,100]  type:#integer fieldwidth:60 pos:[110,335]
	
	     label l13 "Spawn Scale Var:"  pos:[10,360]
	     spinner sp_SpawnScalevar "" range:[0,100000,50]  type:#integer fieldwidth:60 pos:[110,360]
	 )
	 
	 group "Gravity Parameters"
     (
		  label l5 "Gravity:" pos:[10,405]
	     spinner sp_gravity "" range:[0,1000000,500]   fieldwidth:60 pos:[110,405]
 	
		 label l10 "Spawn Gravity:"  pos:[10,430]
	     spinner sp_SpawnGravity "" range:[0,100000,500]  fieldwidth:60  pos:[110,430]
	 )
	Button btn_pf "Open PF Source"  width:190 height:30 pos:[5,460] 

	Button selectdeflector "Select Deflector" width:190 pos:[5,490] 
	
	Button calculate "CREATE" width:190 height:30 pos:[5,520] 
	
	
	on btn_pf pressed do particleFlow.openParticleView()
	on calculate pressed do
	(
		if(isvalidnode pick.object)then
		(
		vn_pfs = PF_Source()
		vn_pfs.dir = [0,0,-1]
		vn_pfs.Quantity_Viewport = 100
		particleFlow.BeginEdit()
		--
		op1 = Birth()
        op1.Emit_Stop = 500*160
        op1.amount = sp_count.value
		--
		op2 = Position_Object()
        op2.Emitter_Objects = #( pick.object)
		--
		op3 = Speed_By_Surface()
		op3.Surface_Objects = #(pick.object)
		op3.Speed_Value = sp_speed.value
		op3.Divergence = sp_div.value
		op3.Speed_Variation = sp_var.value
		--
		op4 =  Force()
		if(isvalidnode $VN_Gravity_01)then
			(
				--nothing
			)else
			(
				gravity_vn = Gravity()
				gravity_vn.dir = [0,0,-1]
				gravity_vn.name ="VN_Gravity_01"
			)
		op4.Force_Space_Warps = #($VN_Gravity_01)
		op4.Influence = sp_gravity.value
		--
		op5 = Collision_Spawn()
		if(isvalidnode $VN_Deflector_01)then
			(
				--nothing
			)else
			(
				deflector_vn = UDeflector()
				deflector_vn.name ="VN_Deflector_01"
				deflector_vn.bounce = 0.3
				deflector_vn.bouncevar = 100
                deflector_vn.chaos = 100
			)
		op5.Collision_Nodes = #($VN_Deflector_01)
		op5.Number_of_Offsprings = sp_Offsprings.value
		op5.Speed_Variation = sp_speedvar.value
		--
		op6 = ShapeLibrary()-- ShapeLibrary()
		op6.Scale_Value = sp_scale.value
		op6.size = 3.6
		op6.Use_Scale = on
		op6.Scale_Variation = sp_scalevar.value
		op6.Type_3D = 6
		--
		op7 = Material_Static()
		vn_water_mat = vraymtl()
		vn_water_mat.Reflection = color 64 64 64
		vn_water_mat.reflection_fresnel = off
		vn_water_mat.Refraction = color 200 200 200
		vn_water_mat.refraction_ior = 1.33
		op7.Assigned_Material = vn_water_mat
		--
        op8 = DisplayParticles()
        op8.color = vn_pfs.wireColor
        op8.type = 6
		op8.color = color 72 174 183
		--
		op9 = RenderParticles()
		--
		ev1 = Event()
        ev1.SetPViewLocation (vn_pfs.X_Coord) (vn_pfs.Y_Coord+100)
        particleFlow.EndEdit()
        ev1.AppendAction op1
        ev1.AppendAction op2
        ev1.AppendAction op3
		ev1.AppendAction op4
        ev1.AppendAction op5
		ev1.AppendAction op6
		ev1.AppendAction op7
		ev1.AppendAction op8
		--
        
		-----------------------------------------------------------------
		particleFlow.BeginEdit()
        ev_1 = Event()
	    ev_1.setPViewLocation -56 343
		--
		op_1 =  Force()
		op_1.Force_Space_Warps = #($VN_Gravity_01)
		op_1.Influence = sp_SpawnGravity.value
		
		op_2 =DeleteParticles()
		op_2.type = 2
		op_2.Life_Span = sp_Spawnlife.value*160
		--
		op_3 =ShapeLibrary()
		op_3.Scale_Value = sp_SpawnScale.value
		op_3.size = 1.5
		op_3.Use_Scale = on
		op_3.Scale_Variation = sp_SpawnScalevar.value
		op_3.Type_3D = 6
		--
		op_4 = Material_Static()
		vn_water_mat2 = vraymtl()
		vn_water_mat2.Diffuse = color 255 255 255
		vn_water_mat2.Reflection = color 64 64 64
		vn_water_mat2.reflection_fresnel = off
		vn_water_mat2.Refraction = color 150 150 150
		vn_water_mat2.refraction_ior = 1.33
		op_4.Assigned_Material = vn_water_mat2
		 --
		op_5 = DisplayParticles()
        op_5.color = ev_1.wireColor
		op_5.type = 6
		op_5.color = color 142 222 229
		--
		particleFlow.EndEdit()
		
		ev_1.appendAction op_1
        ev_1.appendAction op_2
		ev_1.appendAction op_3
		ev_1.appendAction op_4
        ev_1.appendAction op_5
		
		-----------------------------------------------------------------
        op5.setNextActionList  op5 ev_1
		vn_pfs.AppendAction op9
        vn_pfs.AppendInitialActionList ev1
		-----------------------------------------------------------------
		--particleFlow.openParticleView()
		)else
		(
			messagebox "Select Source objects"
		)
		
	)
	
	on sp_count changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op1.amount = val
		)
		
	)
	on sp_speed changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op3.Speed_Value = val
		)
		
	)
	on sp_div changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op3.Divergence =val
		)
		
	)
	

	on sp_var changed val do
	(
		if (isvalidnode vn_pfs)then
		(
		 op3.Speed_Variation =val
		)
		
	)
	
	
	on sp_gravity changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op4.Influence = val
		)
		
	)
	
	on sp_Offsprings changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op5.Number_of_Offsprings = val
		)
		
	)

	on sp_speedvar changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op5.Speed_Variation = val
		)
		
	)

	on sp_scale changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op6.Scale_Value = val
		)
		if(val < sp_scalevar.value)then
			(
				sp_scalevar.value = val
			)
	)

	on sp_scalevar changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op6.Scale_Variation = val
		)
		if(val > sp_scale.value)then
			(
				sp_scale.value = val
			)
	)
	
	on sp_SpawnGravity changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op_1.Influence = val
		)
		
	)
	
	on sp_Spawnlife changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op_2.Life_Span = val*160
		)
		
	)

	on sp_SpawnScale changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op_3.Scale_Value = val
		)
		if(val < sp_SpawnScalevar.value)then
			(
				sp_SpawnScalevar.value = val
			)
	)
	
	on sp_SpawnScalevar changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op_3.Scale_Variation = val
		)
		if(val > sp_SpawnScale.value)then
			(
				sp_SpawnScale.value = val
			)
	)
	---------------------------------------
	on pick picked obj do 
	(
		picked_obj.text = obj.name
		if (isvalidnode vn_pfs)then
		(
		 op2.Emitter_Objects = #( obj)
		 --
		 op3.Surface_Objects = #(obj)
		)
	)
	
	on selectdeflector pressed do
	(
		if(isvalidnode $VN_Deflector_01)then select $VN_Deflector_01
		max modify mode 
	)
)
createdialog vnfountain 200 555 150 90
