/*
by: Vhid Najafi
mail: geo.vahid@gmail.com
www.vnplugin.com
modify this at your own risk
*/---------------------------------------------------------------

try(destroydialog Fire_works)catch()
rollout Fire_works "Fire 1.0.0"
(
	local vn_pfs
    local op1
	local op2
	local vn_particle_ege_5
	local vn_particle_ege_25
	local vn_particle_ege_35
	pickbutton pick "Pick Object" autoDisplay:false width:190 pos:[5,5] 
	label picked_obj ".............." pos:[75,30]
	pickbutton pick_cam "Pick Camera" autoDisplay:false width:190 pos:[5,50] 
	label picked_cam ".............." pos:[75,75]
	
	group "Source Count"
     (
	  label l1 "Count:" pos:[10,110]
	  spinner sp_count "" range:[1,1000,20] type:#integer pos:[110,110] fieldwidth:60
	
	  label l2 "Stop Time:" pos:[10,135]
	  spinner sp_stop "" range:[0,10000,500] type:#integer pos:[110,135] fieldwidth:60
	 )
	 group "Colors 1"
     (
		 colorpicker col1 "" color:(color 255 255 255) fieldWidth:175 height:20 pos:[10,180]
		 colorpicker col2 "" color:(color 0 250 141) fieldWidth:175 height:20 pos:[10,200]
		 colorpicker col3 "" color:(color 222 0 255) fieldWidth:175 height:20 pos:[10,220]
	 )
	 group "Colors 2"
     (
		 colorpicker col4 "" color:(color 255 255 255) fieldWidth:175 height:20 pos:[10,270]
		 colorpicker col5 "" color:(color 255 72 0) fieldWidth:175 height:20 pos:[10,290]
		 colorpicker col6 "" color:(color 102 255 0) fieldWidth:175 height:20 pos:[10,310]
	 )
	 group "Colors 3"
     (
		 colorpicker col7 "" color:(color 255 255 255) fieldWidth:175 height:20 pos:[10,360]
		 colorpicker col8 "" color:(color 255 246 0) fieldWidth:175 height:20 pos:[10,380]
		 colorpicker col9 "" color:(color 143 0 0) fieldWidth:175 height:20 pos:[10,400]
	 )
	Button btn_pf "Open PF Source"  width:190 height:30 pos:[5,430] 

	Button calculate "CREATE" width:190 height:30 pos:[5,470] 
	
	
	on btn_pf pressed do particleFlow.openParticleView()
	on calculate pressed do
	(
		if(isvalidnode pick.object and isvalidnode pick_cam.object)then
		(
		vn_pfs = PF_Source()
		vn_pfs.Particle_Amount_Limit = 1000000
		vn_pfs.dir = [0,0,-1]
		vn_pfs.Quantity_Viewport = 100
		particleFlow.BeginEdit()
		--
		op1 = Birth()
		op1.Emit_Start = 0*160
        op1.Emit_Stop =  sp_stop.value*160
        op1.amount = sp_count.value
		--
		op2 = Position_Object()
        op2.Emitter_Objects = #( pick.object)
		--
		op3 =Speed()
		op3.speed = 2500
		op3.variation = 35	
		op3.Divergence = 35
		--	
		op4=	Shape_Facing()
		op4.Look_At_Object = pick_cam.object
		op4.parallel = on
		op4.units = 50	
		--
		op5 = Material_Static()
		vn_racket_mat = vraymtl()
		vn_racket_mat.effectsChannel =1
		vn_racket_mat.Diffuse = color 255 223 0
		vn_racket_mat.selfIllumination = color 255 223 0
		vn_grad_map = Gradient_Ramp ()
		vn_grad_map.Gradient_Type = 8
		vn_grad_map.output.invert =true
		vn_racket_mat.texmap_opacity = vn_grad_map
		op5.Assigned_Material = vn_racket_mat
		--
		op6 = Spawn()
		op6.Spawn_Type = 1
		op6.Spawn_Rate = 300
		op6.Speed_Inherited = -20
		op6.Speed_Variation = 100
		op6.Divergence = 15
		--
		op7= Age_Test()
		op7.Test_Value = 8800
		op7.variation = 3200
		--
		op8 = DisplayParticles()
        op8.color = vn_pfs.wireColor
        op8.type = 6
		op8.color = color 255 223 0
		--
		op9 = RenderParticles()
		----------------------------------------------
		ev1 = Event()
        ev1.SetPViewLocation (vn_pfs.X_Coord) (vn_pfs.Y_Coord+100)
        particleFlow.EndEdit()
        ev1.AppendAction op1
        ev1.AppendAction op2
        ev1.AppendAction op3
		ev1.AppendAction op4
        ev1.AppendAction op5
		ev1.AppendAction op6
		ev1.AppendAction op7
		ev1.AppendAction op8
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		particleFlow.BeginEdit()
        ev2 = Event()
	    ev2.setPViewLocation -300 340
		--
		op2_1 =  Force()
		if(isvalidnode $VN_wind_04)then
			(
				--nothing
			)else
			(
				wind_vn = wind()
				wind_vn.strength =0
				wind_vn.turbulence = 0.12
				wind_vn.frequency = 0.18
				wind_vn.baseobject.scale = 0.01
				wind_vn.name ="VN_wind_04"
			)	
		op2_1.Force_Space_Warps = #($VN_wind_04)
		--	
		op2_2 = Material_Dynamic()
		trace_mat= standard()
		--trace_mat.effectsChannel =5
		trace_mat.opacityType = 2
		vn_particle_ege_1 =Particle_Age ()
		vn_particle_ege_1.color1 = color 255 255 255
		vn_particle_ege_1.color2 = color 255 162 0
		vn_particle_ege_1.color3 = color 154 0 0
		vn_particle_ege_1.age2 = 10
		trace_mat.diffuseMap = vn_particle_ege_1
		trace_mat.useSelfIllumColor = on
		trace_mat.selfillumMap = vn_particle_ege_1
		trace_mat.opacityMap = Mask ()
		vn_particle_ege_2 =Particle_Age ()
		vn_particle_ege_2.color1 = color 70 70 70
		vn_particle_ege_2.color2 = color 30 30 30
		vn_particle_ege_2.color3 = color 0 0 0
		trace_mat.opacityMap.map = vn_particle_ege_2
		trace_mat.opacityMap.Mask =vn_grad_map
		op2_2.Assigned_Material = trace_mat
		--
		 op2_3 = DeleteParticles()
		 op2_3.type = 2	
		 op2_3.Life_Span = 15*160
         op2_3.variation = 5*160
		--
        op2_4= ScaleParticles()	
		op2_4.type = 3
		op2_4.bias = 2
		op2_4.X_Scale_Factor = 80
        op2_4.Y_Scale_Factor = 80
        op2_4.Z_Scale_Factor = 80
		op2_4.X_Scale_Variation = 50 --animated
        op2_4.Y_Scale_Variation = 50 --animated
        op2_4.Z_Scale_Variation = 50 --animated
        op2_4.Sync_Type = 2
		--
		op2_5 = DisplayParticles()
        op2_5.color = vn_pfs.wireColor
        op2_5.type = 6
		op2_5.color = color 255 255 255
		particleFlow.EndEdit()
		--
		ev2.appendAction op2_1
        ev2.appendAction op2_2
		ev2.appendAction op2_3
		ev2.appendAction op2_4
		ev2.appendAction op2_5
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		particleFlow.BeginEdit()
        ev3 = Event()
	    ev3.setPViewLocation 0 500
		--
		op3_1= Split_Amount()
		op3_1.ratio = 25
		op3_1.Random_Seed = 21292
		--
		op3_2= Split_Amount()
		op3_2.ratio = 30
		op3_2.Random_Seed = 20710
		--
		op3_3= Split_Amount()
		op3_3.ratio = 50
		op3_3.Random_Seed = 23298
		--
		op3_4= Send_Out()
		--
		op3_5 = DisplayParticles()
        op3_5.color = vn_pfs.wireColor
        op3_5.type = 2
		op3_5.color = color 255 255 255
		particleFlow.EndEdit()
		--
		ev3.appendAction op3_1
        ev3.appendAction op3_2
		ev3.appendAction op3_3
		ev3.appendAction op3_4
		ev3.appendAction op3_5
		--------------------------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		-------------------------------------------------------------------------------------------------- 1
		particleFlow.BeginEdit()
        ev4 = Event()
	    ev4.setPViewLocation 0 660
		--
		op4_1= Spawn()
		op4_1.Delete_Parent = on
		op4_1.Number_of_Offsprings = 60
        op4_1.Offsprings_Variation = 10
		op4_1.Speed_Inherited = 0
		--
		op4_2= Speed()
		op4_2.speed = 1300
        op4_2.variation = 300
		op4_2.direction = 3
		--
		op4_3 =  Force()
		if(isvalidnode $VN_gravity_04)then
			(
				--nothing
			)else
			(
				gravity_vn = gravity()
				gravity_vn.dir = [0,0,-1]
				gravity_vn.name ="VN_gravity_04"
			)	
		if(isvalidnode $VN_drag_04)then
			(
				--nothing
			)else
			(
				 drag_vn = drag()
				 drag_vn.timeOff = 500*160
				 drag_vn.dampingX = 10
                 drag_vn.dampingY = 10
                 drag_vn.dampingZ = 10
				 drag_vn.name ="VN_drag_04"
			)	
		op4_3.Influence = 100
		op4_3.Force_Space_Warps = #($VN_gravity_04,$VN_drag_04)
		--	
		op4_4 =  Force()
		op4_4.Force_Space_Warps = #($VN_wind_04)
		--
        op4_5= ScaleParticles()	
		op4_5.type = 3
		op4_5.bias = 2
		op4_5.X_Scale_Factor = 40
        op4_5.Y_Scale_Factor = 40
        op4_5.Z_Scale_Factor = 40
		op4_5.X_Scale_Variation = 20 --animated
        op4_5.Y_Scale_Variation = 20 --animated
        op4_5.Z_Scale_Variation = 20 --animated
        op4_5.Sync_Type = 2
		--
		op4_6= Spawn()
		op4_6.Spawn_Type = 1	
		op4_6.Spawn_Rate = 100
		op4_6.Speed_Inherited = 10
        op4_6.Speed_Variation = 50
		--
		op4_7= Spawn()
		op4_7.Spawn_Type = 1	
		op4_7.Spawn_Rate = 150
		op4_7.Speed_Inherited = 0
        op4_7.Speed_Variation = 0
		--	
		op4_8 = Material_Dynamic()
		explude_mat= standard()
		--explude_mat.effectsChannel =6
		explude_mat.opacityType = 2
		explude_mat.Diffuse=color 255 255 255
		explude_mat.opacityMap = Mask ()
		vn_particle_ege_3 =Particle_Age ()
		vn_particle_ege_3.color1 = color 255 255 255
		vn_particle_ege_3.color2 = color  255 255 255
		vn_particle_ege_3.color3 = color 0 0 0
		vn_particle_ege_3.age2=60
		explude_mat.opacityMap.map = vn_particle_ege_3
		explude_mat.opacityMap.Mask =vn_grad_map
		op4_8.Assigned_Material = explude_mat
		--
		 op4_9 = DeleteParticles()
		 op4_9.type = 2	
		 op4_9.Life_Span = 75*160
         op4_9.variation = 25*160
		--
		op4_10 = DisplayParticles()
        op4_10.color = vn_pfs.wireColor
        op4_10.type = 2
		op4_10.color = color 255 255 255
		particleFlow.EndEdit()
		--
		ev4.appendAction op4_1
		ev4.appendAction op4_2
		ev4.appendAction op4_3
		ev4.appendAction op4_4
		ev4.appendAction op4_5
		ev4.appendAction op4_6
		ev4.appendAction op4_7
		ev4.appendAction op4_8
		ev4.appendAction op4_9
		ev4.appendAction op4_10
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		particleFlow.BeginEdit()
        ev5 = Event()
	    ev5.setPViewLocation 0 920
		--	
		op5_1 = Material_Dynamic()
		traceExplution_mat= standard()
		--traceExplution_mat.effectsChannel =1
		traceExplution_mat.opacityType = 2
		vn_particle_ege_5 =Particle_Age ()
		vn_particle_ege_5.color1 = col1.color
		vn_particle_ege_5.color2 = col2.color
		vn_particle_ege_5.color3 = col3.color
		vn_particle_ege_5.age2 = 10
		traceExplution_mat.diffuseMap = vn_particle_ege_5
		traceExplution_mat.useSelfIllumColor = on
		traceExplution_mat.selfillumMap = vn_particle_ege_5
		traceExplution_mat.opacityMap = Mask ()
		vn_particle_ege_52 =Particle_Age ()
		vn_particle_ege_52.color1 = color 150 150 150
		vn_particle_ege_52.color2 = color 90 90 90
		vn_particle_ege_52.color3 = color 0 0 0
		traceExplution_mat.opacityMap.map = vn_particle_ege_52
		traceExplution_mat.opacityMap.Mask =vn_grad_map
		op5_1.Assigned_Material = traceExplution_mat
		--
		op5_2 =  Force()
		op5_2.Force_Space_Warps = #($VN_wind_04)
		--
		 op5_3 = DeleteParticles()
		 op5_3.type = 2	
		 op5_3.Life_Span = 50*160
         op5_3.variation = 25*160
		--
        op5_4= ScaleParticles()	
		op5_4.type = 3
		op5_4.bias = 2
		op5_4.X_Scale_Factor = 75
        op5_4.Y_Scale_Factor = 75
        op5_4.Z_Scale_Factor = 75
		op5_4.X_Scale_Variation = 50 --animated
        op5_4.Y_Scale_Variation = 50 --animated
        op5_4.Z_Scale_Variation = 50 --animated
        op5_4.Sync_Type = 2
		--
		op5_5 = DisplayParticles()
        op5_5.color = vn_pfs.wireColor
        op5_5.type = 6
		op5_5.color = color 255 255 255
		particleFlow.EndEdit()
		--
		ev5.appendAction op5_1
		ev5.appendAction op5_2
		ev5.appendAction op5_3
		ev5.appendAction op5_4
		ev5.appendAction op5_5
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		particleFlow.BeginEdit()
        ev6 = Event()
	    ev6.setPViewLocation 0 1100
		--
		op6_1 = Material_Static()
		sparkly_bits_mat = standard()
		sparkly_bits_mat.effectsChannel =1
		sparkly_bits_mat.Diffuse=color 255 255 255
		sparkly_bits_mat.useSelfIllumColor = on
		sparkly_bits_mat.selfIllumColor = color 255 255 255
		sparkly_bits_mat.opacityType = 2
		vn_grad_map = Gradient()
		vn_grad_map.gradienttype = 1
		vn_grad_map.color2 = color 100 100 100
		vn_grad_map.color3 = color 100 100 100
		sparkly_bits_mat.opacityMap = vn_grad_map
		op6_1.Assigned_Material = sparkly_bits_mat
		--
		--
		op6_2= Speed()
		op6_2.speed = 600
        op6_2.variation = 300
		op6_2.direction = 3
		--
		 op6_3 = DeleteParticles()
		 op6_3.type = 2	
		 op6_3.Life_Span = 10*160
         op6_3.variation = 5*160
		--
        op6_4= ScaleParticles()	
		op6_4.type = 3
		op6_4.bias = 2
		op6_4.X_Scale_Factor = 50
        op6_4.Y_Scale_Factor = 50
        op6_4.Z_Scale_Factor = 50
		op6_4.X_Scale_Variation = 50 --animated
        op6_4.Y_Scale_Variation = 50 --animated
        op6_4.Z_Scale_Variation = 50 --animated
        op6_4.Sync_Type = 2
		--
		op6_5 = DisplayParticles()
        op6_5.color = vn_pfs.wireColor
        op6_5.type = 6
		op6_5.color = color 255 255 255
		particleFlow.EndEdit()
		--
		ev6.appendAction op6_1
		ev6.appendAction op6_2
		ev6.appendAction op6_3
		ev6.appendAction op6_4
		ev6.appendAction op6_5
		--------------------------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		-------------------------------------------------------------------------------------------------- 2
		particleFlow.BeginEdit()
        ev7 = Event()
	    ev7.setPViewLocation 0 660
		--
		op7_1= Spawn()
		op7_1.Delete_Parent = on
		op7_1.Number_of_Offsprings = 60
        op7_1.Offsprings_Variation = 10
		op7_1.Speed_Inherited = 0
		--
		op7_2= Speed()
		op7_2.speed = 800
        op7_2.variation = 200
		op7_2.direction = 3
		--
		op7_3 =  Force()
		op7_3.Influence = 100
		op7_3.Force_Space_Warps = #($VN_gravity_04,$VN_drag_04)
		--	
		op7_4 =  Force()
		op7_4.Force_Space_Warps = #($VN_wind_04)
		--
        op7_5= ScaleParticles()	
		op7_5.type = 3
		op7_5.bias = 2
		op7_5.X_Scale_Factor = 40
        op7_5.Y_Scale_Factor = 40
        op7_5.Z_Scale_Factor = 40
		op7_5.X_Scale_Variation = 20 --animated
        op7_5.Y_Scale_Variation = 20 --animated
        op7_5.Z_Scale_Variation = 20 --animated
        op7_5.Sync_Type = 2
		--
		op7_6= Spawn()
		op7_6.Spawn_Type = 1	
		op7_6.Spawn_Rate = 100
		op7_6.Speed_Inherited = 10
        op7_6.Speed_Variation = 50
		--
		op7_7= Spawn()
		op7_7.Spawn_Type = 1	
		op7_7.Spawn_Rate = 150
		op7_7.Speed_Inherited = 0
        op7_7.Speed_Variation = 0
		--	
		op7_8 = Material_Dynamic()
		op7_8.Assigned_Material = explude_mat
		--
		 op7_9 = DeleteParticles()
		 op7_9.type = 2	
		 op7_9.Life_Span = 75*160
         op7_9.variation = 25*160
		--
		op7_10 = DisplayParticles()
        op7_10.color = vn_pfs.wireColor
        op7_10.type = 2
		op7_10.color = color 255 0 0
		particleFlow.EndEdit()
		--
		ev7.appendAction op7_1
		ev7.appendAction op7_2
		ev7.appendAction op7_3
		ev7.appendAction op7_4
		ev7.appendAction op7_5
		ev7.appendAction op7_6
		ev7.appendAction op7_7
		ev7.appendAction op7_8
		ev7.appendAction op7_9
		ev7.appendAction op7_10
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		particleFlow.BeginEdit()
        ev8 = Event()
	    ev8.setPViewLocation 0 920
		--	
		op8_1 = Material_Dynamic()
		traceExplution_mat_2= standard()
		--traceExplution_mat_2.effectsChannel =2
		traceExplution_mat_2.opacityType = 2
		vn_particle_ege_25 =Particle_Age ()
		vn_particle_ege_25.color1 = col4.color
		vn_particle_ege_25.color2 = col5.color
		vn_particle_ege_25.color3 = col6.color
		vn_particle_ege_25.age2 = 10
		traceExplution_mat_2.diffuseMap = vn_particle_ege_25
		traceExplution_mat_2.useSelfIllumColor = on
		traceExplution_mat_2.selfillumMap = vn_particle_ege_25
		traceExplution_mat_2.opacityMap = Mask ()
		vn_particle_ege_72 =Particle_Age ()
		vn_particle_ege_72.color1 = color 150 150 150
		vn_particle_ege_72.color2 = color 90 90 90
		vn_particle_ege_72.color3 = color 0 0 0
		traceExplution_mat_2.opacityMap.map = vn_particle_ege_72
		traceExplution_mat_2.opacityMap.Mask =vn_grad_map
		op8_1.Assigned_Material = traceExplution_mat_2
		--
		op8_2 =  Force()
		op8_2.Force_Space_Warps = #($VN_wind_04)
		--
		 op8_3 = DeleteParticles()
		 op8_3.type = 2	
		 op8_3.Life_Span = 50*160
         op8_3.variation = 25*160
		--
        op8_4= ScaleParticles()	
		op8_4.type = 3
		op8_4.bias = 2
		op8_4.X_Scale_Factor = 75
        op8_4.Y_Scale_Factor = 75
        op8_4.Z_Scale_Factor = 75
		op8_4.X_Scale_Variation = 50 --animated
        op8_4.Y_Scale_Variation = 50 --animated
        op8_4.Z_Scale_Variation = 50 --animated
        op8_4.Sync_Type = 2
		--
		op8_5 = DisplayParticles()
        op8_5.color = vn_pfs.wireColor
        op8_5.type = 6
		op8_5.color = color 255 0 0
		particleFlow.EndEdit()
		--
		ev8.appendAction op8_1
		ev8.appendAction op8_2
		ev8.appendAction op8_3
		ev8.appendAction op8_4
		ev8.appendAction op8_5
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		particleFlow.BeginEdit()
        ev9 = Event()
	    ev9.setPViewLocation 0 1100
		--
		op9_1 = Material_Static()
		op9_1.Assigned_Material = sparkly_bits_mat
		--
		--
		op9_2= Speed()
		op9_2.speed = 600
        op9_2.variation = 300
		op9_2.direction = 3
		--
		 op9_3 = DeleteParticles()
		 op9_3.type = 2	
		 op9_3.Life_Span = 10*160
         op9_3.variation = 5*160
		--
        op9_4= ScaleParticles()	
		op9_4.type = 3
		op9_4.bias = 2
		op9_4.X_Scale_Factor = 50
        op9_4.Y_Scale_Factor = 50
        op9_4.Z_Scale_Factor = 50
		op9_4.X_Scale_Variation = 50 --animated
        op9_4.Y_Scale_Variation = 50 --animated
        op9_4.Z_Scale_Variation = 50 --animated
        op9_4.Sync_Type = 2
		--
		op9_5 = DisplayParticles()
        op9_5.color = vn_pfs.wireColor
        op9_5.type = 6
		op9_5.color = color 255 0 0
		particleFlow.EndEdit()
		--
		ev9.appendAction op9_1
		ev9.appendAction op9_2
		ev9.appendAction op9_3
		ev9.appendAction op9_4
		ev9.appendAction op9_5
		--------------------------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		-------------------------------------------------------------------------------------------------- 3
		particleFlow.BeginEdit()
        ev10 = Event()
	    ev10.setPViewLocation 0 660
		--
		op10_1= Spawn()
		op10_1.Delete_Parent = on
		op10_1.Number_of_Offsprings = 60
        op10_1.Offsprings_Variation = 10
		op10_1.Speed_Inherited = 0
		--
		op10_2= Speed()
		op10_2.speed = 1600
        op10_2.variation = 500
		op10_2.direction = 3
		--
		op10_3 =  Force()
		op10_3.Influence = 400
		op10_3.Force_Space_Warps = #($VN_gravity_04,$VN_drag_04)
		--	
		op10_4 =  Force()
		op10_4.Force_Space_Warps = #($VN_wind_04)
		--
        op10_5= ScaleParticles()	
		op10_5.type = 3
		op10_5.bias = 2
		op10_5.X_Scale_Factor = 40
        op10_5.Y_Scale_Factor = 40
        op10_5.Z_Scale_Factor = 40
		op10_5.X_Scale_Variation = 20 --animated
        op10_5.Y_Scale_Variation = 20 --animated
        op10_5.Z_Scale_Variation = 20 --animated
        op10_5.Sync_Type = 2
		--
		op10_6= Spawn()
		op10_6.Spawn_Type = 1	
		op10_6.Spawn_Rate = 100
		op10_6.Speed_Inherited = 10
        op10_6.Speed_Variation = 50
		--
		op10_7= Spawn()
		op10_7.Spawn_Type = 1	
		op10_7.Spawn_Rate = 150
		op10_7.Speed_Inherited = 0
        op10_7.Speed_Variation = 0
		--	
		op10_8 = Material_Dynamic()
		op10_8.Assigned_Material = explude_mat
		--
		 op10_9 = DeleteParticles()
		 op10_9.type = 2	
		 op10_9.Life_Span = 75*160
         op10_9.variation = 25*160
		--
		op10_10 = DisplayParticles()
        op10_10.color = vn_pfs.wireColor
        op10_10.type = 2
		op10_10.color = color 0 255 0
		particleFlow.EndEdit()
		--
		ev10.appendAction op10_1
		ev10.appendAction op10_2
		ev10.appendAction op10_3
		ev10.appendAction op10_4
		ev10.appendAction op10_5
		ev10.appendAction op10_6
		ev10.appendAction op10_7
		ev10.appendAction op10_8
		ev10.appendAction op10_9
		ev10.appendAction op10_10
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		particleFlow.BeginEdit()
        ev11 = Event()
	    ev11.setPViewLocation 0 920
		--	
		op11_1 = Material_Dynamic()
		traceExplution_mat_3= standard()
		--traceExplution_mat_3.effectsChannel =3
		traceExplution_mat_3.opacityType = 2
		vn_particle_ege_35 =Particle_Age ()
		vn_particle_ege_35.color1 = col7.color
		vn_particle_ege_35.color2 = col8.color
		vn_particle_ege_35.color3 = col9.color
		vn_particle_ege_35.age2 = 10
		traceExplution_mat_3.diffuseMap = vn_particle_ege_35
		traceExplution_mat_3.useSelfIllumColor = on
		traceExplution_mat_3.selfillumMap = vn_particle_ege_35
		traceExplution_mat_3.opacityMap = Mask ()
		vn_particle_ege_112 =Particle_Age ()
		vn_particle_ege_112.color1 = color 150 150 150
		vn_particle_ege_112.color2 = color 90 90 90
		vn_particle_ege_112.color3 = color 0 0 0
		traceExplution_mat_3.opacityMap.map = vn_particle_ege_112
		traceExplution_mat_3.opacityMap.Mask =vn_grad_map
		op11_1.Assigned_Material = traceExplution_mat_3
		--
		op11_2 =  Force()
		op11_2.Force_Space_Warps = #($VN_wind_04)
		--
		 op11_3 = DeleteParticles()
		 op11_3.type = 2	
		 op11_3.Life_Span = 50*160
         op11_3.variation = 25*160
		--
        op11_4= ScaleParticles()	
		op11_4.type = 3
		op11_4.bias = 2
		op11_4.X_Scale_Factor = 75
        op11_4.Y_Scale_Factor = 75
        op11_4.Z_Scale_Factor = 75
		op11_4.X_Scale_Variation = 50 --animated
        op11_4.Y_Scale_Variation = 50 --animated
        op11_4.Z_Scale_Variation = 50 --animated
        op11_4.Sync_Type = 2
		--
		op11_5 = DisplayParticles()
        op11_5.color = vn_pfs.wireColor
        op11_5.type = 6
		op11_5.color = color 0 255 0
		particleFlow.EndEdit()
		--
		ev11.appendAction op11_1
		ev11.appendAction op11_2
		ev11.appendAction op11_3
		ev11.appendAction op11_4
		ev11.appendAction op11_5
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		particleFlow.BeginEdit()
        ev12 = Event()
	    ev12.setPViewLocation 0 1100
		--
		op12_1 = Material_Static()
		op12_1.Assigned_Material = sparkly_bits_mat
		--
		--
		op12_2= Speed()
		op12_2.speed = 600
        op12_2.variation = 300
		op12_2.direction = 3
		--
		 op12_3 = DeleteParticles()
		 op12_3.type = 2	
		 op12_3.Life_Span = 10*160
         op12_3.variation = 5*160
		--
        op12_4= ScaleParticles()	
		op12_4.type = 3
		op12_4.bias = 2
		op12_4.X_Scale_Factor = 50
        op12_4.Y_Scale_Factor = 50
        op12_4.Z_Scale_Factor = 50
		op12_4.X_Scale_Variation = 50 --animated
        op12_4.Y_Scale_Variation = 50 --animated
        op12_4.Z_Scale_Variation = 50 --animated
        op12_4.Sync_Type = 2
		--
		op12_5 = DisplayParticles()
        op12_5.color = vn_pfs.wireColor
        op12_5.type = 6
		op12_5.color = color 0 255 0
		particleFlow.EndEdit()
		--
		ev12.appendAction op12_1
		ev12.appendAction op12_2
		ev12.appendAction op12_3
		ev12.appendAction op12_4
		ev12.appendAction op12_5
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		----------------------------------------------
		op6.setNextActionList  op6 ev2
		op7.setNextActionList  op7 ev3
		op3_1.setNextActionList  op3_1 ev4
		op3_2.setNextActionList  op3_2 ev7
		op3_3.setNextActionList  op3_3 ev10
		op4_6.setNextActionList  op4_6 ev5
		op4_7.setNextActionList  op4_7 ev6
		op7_6.setNextActionList  op7_6 ev8
		op7_7.setNextActionList  op7_7 ev9
		op10_6.setNextActionList  op10_6 ev11
		op10_7.setNextActionList  op10_7 ev12
		vn_pfs.AppendAction op9
        vn_pfs.AppendInitialActionList ev1
		
		
		/*
		op3 =  Force()
		if(isvalidnode $VN_Gravity_03)then
			(
				--nothing
			)else
			(
				gravity_vn = Gravity()
				gravity_vn.dir = [0,0,-1]
				gravity_vn.name ="VN_Gravity_03"
			)
		if(isvalidnode $VN_wind_03)then
			(
				--nothing
			)else
			(
				wind_vn = wind()
				wind_vn.strength = 0.1
				wind_vn.turbulence = sp_Turbulence.value
				wind_vn.frequency = 1
				wind_vn.name ="VN_wind_03"
			)	
		op3.Force_Space_Warps = #($VN_Gravity_03 , $VN_wind_03)
		op3.Influence = sp_gravity.value
		--
		op4=Speed_By_Surface()
		op4.Surface_Objects =  #( pick.object)
		op4.Speed_Value = sp_speed.value
		op4.Direction_Type = 2
		op4.Speed_Variation = sp_speedVar.value
		op4.Speed_Type = 1
		--
		op5 = Spawn()
		op5.Spawn_Type = 1
		op5.Speed_Inherited = 0
		op5.Divergence = 0
		op5.Spawn_Rate = sp_Spawn.value
		--
		op6 = ShapeLibrary()-- ShapeLibrary()
		op6.Scale_Value = sp_scale.value
		op6.size = 2
		op6.Use_Scale = on
		op6.Scale_Variation = sp_scale_var.value
		op6.Type_3D = 14
		--
        op8 = DisplayParticles()
        op8.color = vn_pfs.wireColor
        op8.type = 6
		op8.color = color 45 103 124
		--
		op9 = RenderParticles()
		--
		ev1 = Event()
        ev1.SetPViewLocation (vn_pfs.X_Coord) (vn_pfs.Y_Coord+100)
        particleFlow.EndEdit()
        ev1.AppendAction op1
        ev1.AppendAction op2
        ev1.AppendAction op3
		ev1.AppendAction op4
        ev1.AppendAction op5
		ev1.AppendAction op6
		ev1.AppendAction op7
		ev1.AppendAction op8
		--
        
		-----------------------------------------------------------------
		particleFlow.BeginEdit()
        ev_1 = Event()
	    ev_1.setPViewLocation -300 350
		--
		op_1 = ScaleParticles()
		op_1.type = 4
		op_1.X_Scale_Factor = sp_Spawnscale.value
		op_1.Y_Scale_Factor = sp_Spawnscale.value
		op_1.Z_Scale_Factor = sp_Spawnscale.value
		op_1.X_Scale_Variation = sp_Spawnscalevar.value
		op_1.Y_Scale_Variation = sp_Spawnscalevar.value
		op_1.Z_Scale_Variation = sp_Spawnscalevar.value
		op_1.bias = 2
		--
		op_2 =DeleteParticles()
		op_2.type = 2
		op_2.Life_Span = sp_Spawnlife.value*160
        op_2.variation = sp_Spawnlifevar.value*160
		--
		op_3 = Material_Static()
		op_3.Assigned_Material = vn_water_mat
		 --
		op_4 = DisplayParticles()
        op_4.color = ev_1.wireColor
		op_4.type = 6
		op_4.color = color 45 103 124
		--
		particleFlow.EndEdit()
		
		ev_1.appendAction op_1
        ev_1.appendAction op_2
		ev_1.appendAction op_3
		ev_1.appendAction op_4
		-----------------------------------------------------------------
		particleFlow.BeginEdit()
		--
		op2_1 = Birth()
		op2_1.Emit_Start = 0
        op2_1.Emit_Stop =  0
        op2_1.amount = sp_dropCount.value
		--
		op2_2 = Position_Object()
        op2_2.Emitter_Objects = #( pick.object)
		--
		op2_3 = ShapeLibrary()-- ShapeLibrary()
		op2_3.Scale_Value = sp_DropScale.value
		op2_3.size = 2
		op2_3.Use_Scale = on
		op2_3.Scale_Variation = sp_DropScaleVar.value
		op2_3.Type_3D = 14
		--
		op2_4 = Material_Static()
		vn_water_mat = vraymtl()
		vn_water_mat.Diffuse = color 255 255 255
		op2_4.Assigned_Material = vn_water_mat
		--
        op2_5 = DisplayParticles()
        op2_5.color = vn_pfs.wireColor
        op2_5.type = 6
		op2_5.color = color 45 103 124
		--
		--op9 = RenderParticles()
		--
		ev2 = Event()
        ev2.SetPViewLocation (vn_pfs.X_Coord+230) (vn_pfs.Y_Coord+100)
        particleFlow.EndEdit()
        ev2.AppendAction op2_1
        ev2.AppendAction op2_2
        ev2.AppendAction op2_3
		ev2.AppendAction op2_4
		ev2.AppendAction op2_5
		
		-----------------------------------------------------------------
        op5.setNextActionList  op5 ev_1
		vn_pfs.AppendAction op9
        vn_pfs.AppendInitialActionList ev1
		vn_pfs.AppendInitialActionList ev2
		-----------------------------------------------------------------
		--particleFlow.openParticleView()
		*/
		)else
		(
			messagebox "Select Source objects\nand\nSelect camera"
		)
		
	)
	
	on sp_count changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op1.amount = val
		)
		
	)

	on sp_stop changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op1.Emit_Stop = val*160
		)
		
	)
	---------------------------------------
	on pick picked obj do 
	(
		picked_obj.text = obj.name
		if (isvalidnode vn_pfs)then
		(
		 op2.Emitter_Objects = #( obj)
		)
	)
	
	on pick_cam picked obj do 
	(
		picked_cam.text = obj.name
		if (isvalidnode vn_pfs)then
		(
		 op4.Look_At_Object =  obj
		)
	)
	
	on col1 changed val do vn_particle_ege_5.color1 = val
	on col2 changed val do vn_particle_ege_5.color2 = val
	on col3 changed val do vn_particle_ege_5.color3 = val
	
	on col4 changed val do vn_particle_ege_25.color1 = val
	on col5 changed val do vn_particle_ege_25.color2 = val
	on col6 changed val do vn_particle_ege_25.color3 = val
		
	on col7 changed val do vn_particle_ege_35.color1 = val
	on col8 changed val do vn_particle_ege_35.color2 = val
	on col9 changed val do vn_particle_ege_35.color3 = val
	-----------------------------------------
	on Fire_works open do
	(
		for i=1 to $*.count do
		(
			if(superclassof $*[i]==camera)then
			(
				pick_cam.object = $*[i]
				picked_cam.text = $*[i].name
				exit
			)
		)
	)
)
createdialog Fire_works 200 510 150 90
